"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSNormalizer = void 0;
const Utils_1 = require("../../Compiler/Utils");
const JSTranslator_1 = require("../../Translator/JSTranslator");
class JSNormalizer {
    constructor(trs, externals, executor, nat = JSTranslator_1.makeBigNat) {
        this.trs = trs;
        this.externals = externals;
        this.executor = executor;
        this.nat = nat;
        this.trs = trs;
        this.externals = externals;
    }
    getOutputExpr(query, jst) {
        return `showTerm(${jst.translateJSExpr(jst.callTerm(jst.renameTerm(Utils_1.stringifyQueryVars(query))))})`;
    }
    normalize(query) {
        return __awaiter(this, void 0, void 0, function* () {
            const jst = new JSTranslator_1.JSTranslator(this.trs, this.externals, this.nat);
            const source = jst.translate();
            const out = yield this.executor(source, this.getOutputExpr(query, jst));
            return Utils_1.defined(jst.parseRenamedTerm(out));
        });
    }
}
exports.JSNormalizer = JSNormalizer;
