import { Fun, Term } from "../Parser/Types";
import { StepNormalizer } from "../Normalizer/Normalizer";
export declare type Targets = 'js' | 'ocaml' | 'haskell';
export declare const supportedTargets: Targets[];
export declare type NativeExternals<Exts extends string = string> = {
    [name in Exts]: (t: Fun, normalizer: StepNormalizer, externals: NativeExternals<string>) => Term;
};
export declare type AnyExternals<Exts extends string = string> = Externals<Targets, Exts> | NativeExternals<Exts>;
export declare type Externals<Target extends Targets, Exts extends string = string> = {
    [key in Exts]: (name: string) => string;
};
export declare type ExternalsFactoryMap<Exts extends string = string> = {
    'native': NativeExternals<Exts>;
    'js': Externals<'js', Exts>;
    'ocaml': Externals<'ocaml', Exts>;
    'haskell': Externals<'haskell', Exts>;
};
export declare type ExternalsFactory<Exts extends string> = <T extends Targets | 'native'>(target: T) => ExternalsFactoryMap<Exts>[T];
export declare const mergeExternals: (...factories: ExternalsFactory<string>[]) => ExternalsFactory<string>;
