import { DecisionTree } from "../Compiler/DecisionTrees/DecisionTree";
import { DecisionTreeTranslator } from "../Compiler/DecisionTrees/DecisionTreeTranslator";
import { Externals } from "../Externals/Externals";
import { Term, TRS } from "../Parser/Types";
export declare const makeBigNat: (nat: string) => string;
export declare const makeNat: (nat: string) => string;
export declare const nullaryVarName: (f: string) => string;
declare type FunCall = {
    funName: string;
    args: JSExpr[];
};
declare type JSExpr = string | FunCall | Term;
export declare class JSTranslator<Exts extends string> extends DecisionTreeTranslator<'js', Exts> {
    private nullaries;
    private nat;
    constructor(trs: TRS, externals: Externals<'js', Exts>, nat?: (nat: string) => string);
    private declareNullarySymbols;
    accessSubterm(parent: string, childIndex: number): string;
    protected init(): void;
    callTerm(term: Term): JSExpr;
    private callOccTerm;
    private translateOccurence;
    translateDecisionTree(name: string, dt: DecisionTree, varNames: string[]): string;
    translateTerm(term: Term): string;
    translateJSExpr(expr: JSExpr): string;
}
export {};
